unit UseLookAheadValuesInCalcRAP;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ppVar, ppCtrls, ppDB, ppPrnabl, ppClass, ppBands, ppCache, Db,
  DBTables, ppDBPipe, ppComm, ppRelatv, ppProd, ppReport, ppUtils,
  ppModule, raCodMod, ppEndUsr, raIDE, daDataView, daQueryDataView,
  daDBBDE, daDataModule, daIDE,
  ppRTTI;

type
  TForm1 = class(TForm)
    ppReport1: TppReport;
    Button1: TButton;
    Button2: TButton;
    ppDesigner1: TppDesigner;
    ppHeaderBand1: TppHeaderBand;
    ppDetailBand1: TppDetailBand;
    ppDBText2: TppDBText;
    ppDBText3: TppDBText;
    ppVariable1: TppVariable;
    ppFooterBand1: TppFooterBand;
    ppGroup1: TppGroup;
    ppGroupHeaderBand1: TppGroupHeaderBand;
    ppDBText1: TppDBText;
    ppDBCalc1: TppDBCalc;
    ppLabel1: TppLabel;
    ppLabel2: TppLabel;
    ppGroupFooterBand1: TppGroupFooterBand;
    ppDBCalc2: TppDBCalc;
    ppVariable2: TppVariable;
    ppLine1: TppLine;
    raCodeModule1: TraCodeModule;
    daDataModule1: TdaDataModule;
    daBDEQueryDataView1: TdaBDEQueryDataView;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public

  end;


  {TmyTppVariableRTTI

    This class extends the default TppVariable RTTI for RAP. It adds support
    for the Variable.SaveToCache method that is required for this example. This
    class is registered at run-time - see the initialization section of this
    unit.}
    
  TmyTppVariableRTTI = class(TraTppVariableRTTI)
    public
      class function GetParams(const aMethodName: String): TraParamList; override;
      class procedure GetPropList(aClass: TClass; aPropList: TraPropList); override;
      class function  GetPropRec(aClass: TClass; const aPropName: String; var aPropRec: TraPropRec): Boolean; override;
      class function  CallMethod(aObject: TObject; const aMethodName: String; aParams: TraParamList; aGet: Boolean): Boolean; override;

    end;


var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
begin
  ppReport1.Print;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  ppDesigner1.ShowModal;
end;

{ TmyTppVariableRTTI }

{------------------------------------------------------------------------------}
{ TmyTppVariableRTTI.GetPropList }

class procedure TmyTppVariableRTTI.GetPropList(aClass: TClass; aPropList: TraPropList);
begin

  inherited;

  {add public methods}
  aPropList.AddMethod('SaveToCache');

end;

{------------------------------------------------------------------------------}
{ TmyTppVariableRTTI.GetParams }

class function TmyTppVariableRTTI.GetParams(const aMethodName: String): TraParamList;
begin

  if (CompareText(aMethodName, 'SaveToCache') = 0) then
    begin
      Result := TraParamList.Create;

      Result.AddParam('aCachePageNo', daInteger, nil, '', False, False);
    end


  else
    Result := inherited GetParams(aMethodName);

end; {class function, GetParams}

{------------------------------------------------------------------------------}
{ TmyTppVariableRTTI.GetPropRec }

class function TmyTppVariableRTTI.GetPropRec(aClass: TClass; const aPropName: String; var aPropRec: TraPropRec): Boolean;
begin

  Result := True;

  if (CompareText(aPropName, 'SaveToCache') = 0) then
    MethodToRec(aPropName, True, aPropRec)

  else
    Result := inherited GetPropRec(aClass, aPropName, aPropRec);

end;

{------------------------------------------------------------------------------}
{ TmyTppVariableRTTI.CallMethod }

class function TmyTppVariableRTTI.CallMethod(aObject: TObject; const aMethodName: String; aParams: TraParamList; aGet: Boolean): Boolean;
var
  liPageNo: Integer;
begin

  Result := True;

  if (CompareText(aMethodName, 'SaveToCache') = 0) then
    begin
      aParams.GetParamValue(0, liPageNo);
      TppVariable(aObject).SaveToCache(liPageNo);
    end

  else
    inherited CallMethod(aObject, aMethodName, aParams, aGet);


end;

{******************************************************************************
 *
 ** I N I T I A L I Z A T I O N   /   F I N A L I Z A T I O N
 *
{******************************************************************************}

initialization
  raUnRegisterRTTI(TraTppVariableRTTI);
  raRegisterRTTI(TmyTppVariableRTTI);

finalization

  raUnRegisterRTTI(TmyTppVariableRTTI);



end.
